---
title: 'ARIA: checkbox role'
slug: Web/Accessibility/ARIA/Roles/checkbox_role
tags:
  - ARIA
  - Accessibility
  - NeedsContent
  - Role(2)
  - Rôle
---
<p>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<p><span class="seoSummary">The <a class="external" href="https://www.w3.org/TR/wai-aria-1.1/#checkbox" title="http://www.w3.org/TR/wai-aria/roles#checkbox">checkbox role</a> is used for checkable interactive controls. Elements containing <code>role="checkbox"</code> must also include the <code>aria-checked</code> attribute to expose the checkbox's state to assistive technology.</span></p>

<pre class="brush: html">&lt;span role="checkbox" aria-checked="false" tabindex="0" aria-labelledby="chk1-label"&gt;
&lt;/span&gt; &lt;label id="chk1-label"&gt;Remember my preferences&lt;/label&gt;</pre>

<p>The first rule of ARIA is if a native HTML element or attribute has the semantics and behavior you require, use it instead of re-purposing an element and adding ARIA. Instead use the native <a href="/en-US/docs/Web/HTML/Element/input/checkbox">HTML checkbox</a> of <code><a href="/en-US/docs/Web/HTML/Element/input/checkbox">&lt;input type="checkbox"&gt;</a></code>, which natively provides all the functionality required:</p>

<pre class="brush: html">&lt;input type="checkbox" id="chk1-label"&gt;
&lt;label for="chk1-label"&gt;Remember my preferences&lt;/label&gt;</pre>

<h2 id="Description">Description</h2>

<p>The native <a href="/en-US/docs/Web/HTML/Element/input/checkbox">HTML checkbox</a>  form control can only have two checked states ("checked" or "not checked"), with an <a href="/en-US/docs/Web/HTML/Element/input/checkbox#Indeterminate_state_checkboxes">indeterminate</a> state settable via JavaScript. Similarly, an element with <code>role="checkbox"</code>  can expose three states through the <code>aria-checked</code> attribute: <code>true</code>, <code>false</code>, or <code>mixed</code>.</p>

<p>Since a checkbox is an interactive control, it must be focusable and keyboard accessible. If the role is applied to a non-focusable element, use the <code>tabindex</code> attribute to change this. The expected keyboard shortcut for activating a checkbox is the <kbd>Space</kbd> key.</p>

<p>The developer is required to change the value of the <code>aria-checked</code> attribute dynamically when the checkbox is activated.</p>

<h3 id="Associated_WAI-ARIA_Roles_States_and_Properties">Associated WAI-ARIA Roles, States, and Properties</h3>

<dl>
 <dt>aria-checked</dt>
 <dd>
 <p>The value of <code>aria-checked</code> defines the state of a checkbox. This attribute has one of three possible values:</p>

 <p><code>true</code><br>
      The checkbox is checked<br>
  <code>false</code><br>
      The checkbox is not checked<br>
  <code>mixed</code><br>
      The checkbox is partially checked, or indeterminate</p>
 </dd>
 <dt>tabindex="0"</dt>
 <dd>Used to make it focusable so the assistive technology user can tab to it and start reading right away.</dd>
</dl>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Key</th>
   <th scope="col">Function</th>
  </tr>
  <tr>
   <td><kbd>Space</kbd></td>
   <td>Activates the checkbox</td>
  </tr>
 </tbody>
</table>

<h3 id="Required_JavaScript">Required JavaScript</h3>

<h4 id="Required_event_handlers">Required event handlers</h4>

<dl>
 <dt>onclick</dt>
 <dd>Handle mouse clicks that will change the state of the checkbox by changing the value of the <code>aria-checked</code> attribute and the appearance of the checkbox so it appears checked or unchecked to the sighted user</dd>
 <dt>onKeyPress</dt>
 <dd>Handle the case where the user presses the <kbd>Space</kbd> key to change the state of the checkbox by changing the value of the <code>aria-checked</code> attribute and the appearance of the checkbox so it appears checked or unchecked to the sighted user</dd>
</dl>

<h3 id="Examples">Examples</h3>

<p>The following example creates a simple checkbox element using CSS and JavaScript to handle the checked or unchecked status of the element.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;span role="checkbox" id="chkPref" aria-checked="false" onclick="changeCheckbox()" onKeyPress="changeCheckbox()"
   tabindex="0" aria-labelledby="chk1-label"&gt;&lt;/span&gt;
&lt;label id="chk1-label" onclick="changeCheckbox()" onKeyPress="changeCheckbox()"&gt;Remember my preferences&lt;/label&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css">[role="checkbox"] {
    padding:5px;
}

[aria-checked="true"]::before {
    content: "[x]";
}

[aria-checked="false"]::before {
    content: "[ ]";
}</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js">function changeCheckbox(event) {
    let item = document.getElementById('chkPref');
    switch(item.getAttribute('aria-checked')) {
        case "true":
            item.setAttribute('aria-checked', "false");
            break;
        case "false":
            item.setAttribute('aria-checked', "true");
            break;
    }
}</pre>

<p>{{EmbedLiveSample("Examples", 230, 250)}}</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>When the <code>checkbox</code> role is added to an element, the user agent should do the following:</p>

<ul>
 <li>Expose the element as having a checkbox role in the operating system's accessibility API.</li>
 <li>When the aria-checked value changes, send an accessible state changed event.</li>
</ul>

<p>Assistive technology products should do the following:</p>

<ul>
 <li>Screen readers should announce the element as a checkbox, and optionally provide instructions on how to activate it.</li>
</ul>

<div class="note"><strong>Note:</strong> Opinions may differ on how assistive technology should handle this technique. The information provided above is one of those opinions and therefore not normative.</div>

<h2 id="Best_practices">Best practices</h2>

<p>The first rule of ARIA is: if a native HTML element or attribute has the semantics and behavior you require, use it instead of re-purposing an element and adding an ARIA role, state or property to make it accessible. As such, it is recommended to use the native <a href="/en-US/docs/Web/HTML/Element/input/checkbox">HTML checkbox</a>  using form control instead of recreating a checkbox's functionality with JavaScript and ARIA.</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/HTML/Element/input/checkbox">&lt;input type="checkbox"&gt;</a></code></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Radio_Role">ARIA: radio role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Menuitem_Role">ARIA: menuitem role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Menuitemcheckbox_Role">ARIA: menuitemcheckbox role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Menuitemradio_Role">ARIA: menuitemradio role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Switch_role">ARIA: switch role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Option_role">ARIA: option role</a></li>
</ul>

